/*
 * Copyright (c) 2001, Aslak Hellesy, BEKK Consulting
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 *
 * - Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in the
 *   documentation and/or other materials provided with the distribution.
 *
 * - Neither the name of BEKK Consulting nor the names of its
 *   contributors may be used to endorse or promote products derived from
 *   this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*
 * Change log
 *
 */
package middlegen.swing;

import javax.swing.JList;
import middlegen.Table;

/**
 * @author <a href="mailto:aslak.hellesoy@bekk.no">Aslak Hellesy</a>
 * @created 3. oktober 2001
 * @version $Id: JTableList.java,v 1.4 2002/05/04 12:35:45 rinkrank Exp $
 */
public class JTableList extends JList {

	/**
	 * @todo-javadoc Describe the column
	 */
	private final Table _table;

	/**
	 * @todo-javadoc Describe the column
	 */
	private static ColumnListCellRenderer _renderer = new ColumnListCellRenderer();

	/**
	 * Get static reference to Log4J Logger
	 */
	private static org.apache.log4j.Category _log = org.apache.log4j.Category.getInstance(JTableList.class.getName());


	/**
	 * Creates new JTableList
	 *
	 * @param table Describe what the parameter does
	 * @todo-javadoc Write javadocs for method parameter
	 * @pre table != null
	 */
	public JTableList(Table table) {
		super(new TableListModel(table));
		setCellRenderer(_renderer);
		_table = table;
	}


	/**
	 * Gets the Table attribute of the JTableList object
	 *
	 * @return The Table value
	 */
	public Table getTable() {
		return _table;
	}
}

